Subject: Re: IPoIB: Fix multicast packet drops before join is complete

From: Roland Dreier <[email-masked]>
Date: Fri, 05 Jun 2009 09:56:00 -0700

> ARP is tied to managing small chunks of information about the network
 > infrastructure. Buffering the first few and throwing the rest away is
 > appropriate there for what the ARP protocol intends to do.

Yes, but what the IP stack is doing is queueing a few packets while ARP
is pending and dropping all other packets until the destination ethernet
address is resolved.

 > UDP multicasting can be used for streaming information. And right now the
 > IPoIB layer is dropping thousands of packets whenever there was a pause of
 > a few minutes or when a new multicast group is used and there is some
 > delay that the network need to reestablish the multicast route.

Yes -- and the required IB multicast resolution seems like it is an L2
thing precisely analogous to ARP.  So I think the original IPoIB code
actually was doing the right thing.

 - R.